# DragonOS

**Languages** [中文](README.md)|English

&nbsp;

This project is a operating system running on computer which is in X86_ 64 Architecture . The DragonOS is currently under development!

## Development Environment

GCC>=8.0

bochs==2.7

bximage

<u>Sorry, DragonOS can't run properly on QEMU virtual machine at present.</u>

## How to run?

1. clone the project

2. Run the <u>run.sh</u> 

## To do list:

- [x] multiboot2

- [x] printk

- [x] Simple exception capture and interrupt handling

- [x] APIC

- [x] Primary memory management unit

- [x] SLAB memory pool

- [ ] Keyboard and mouse driver

- [ ] Hard disk driver

- [ ] Driver Framework

- [ ] Network card driver

- [ ] Graphics driver

- [x] First process

- [ ] Process management

- [ ] IPC

- [x] First system call function

- [x] Start dragonos on the physical platform (There is a bug which can make the computer automatically reboot on AMD processor)

- [ ] Multi core boot

- [ ] Multi core scheduling and load balancing

- [ ] FAT32 file system

- [ ] virtual file system

- [ ] Parsing ELF file format

- [ ] Floating point support

- [ ] Implementation of system call library based on POSIX

- [ ] Shell

- [ ] Kernel stack backtracking

- [ ] Dynamic loading module

## Contribute code

If you are willing to develop this project with me, please email me first~

## List of contributors

fslongjin

## Contact with me

Email：longjin@RinGoTek.cn

Blog：[longjin666.cn](https://longjin666.cn)

## Reward

If you like, click the link below and buy me a cup of coffee ~ please leave your GitHub ID in the payment remarks and I will post it to this page

[The reward webpage](https://longjin666.cn/?page_id=54)

## Sponsors

Not yet

## Open source statement

This project adopts GPLv2 LICENSE for open source. You are welcome to use the code of this project on the basis of abiding by the open source license!
**What we support:** using this project to create greater value and contribute code to this project under the condition of abiding by the agreement.
**What we resist**: any non-compliance with the open source license. Including but not limited to: plagiarizing the code of the project as your graduation project and other academic misconduct, as well as commercial closed source use without payment.
If you find any violation of the open source license, we welcome you to send email feedback! Let's build an honest open source community together!
